<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.24 $
 * $Author: tora60 $
 * $Date: 2009/05/13 17:29:35 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 *
 * Bariba-Newsletter Integration by sidewind, http://www.komplett-umsonst.de
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminuser")) {
    mxErrorScreen("Access Denied");
    die();
}

require_once(PMX_SYSTEM_DIR . DS . "mx_userfunctions.php");

/**
 */
function getAllUsersSelectOptions1($user_stat = 1)
{
    global $user_prefix, $prefix;
    $user_stat = (empty($user_stat)) ? 0 : (int)$user_stat;
    $useroptions = "";
    $qry = "SELECT u.uname, u.uid, u.user_ingroup, u.user_stat, ga.access_title
        FROM ${user_prefix}_users AS u
        LEFT JOIN ${prefix}_groups_access AS ga
        ON u.user_ingroup = ga.access_id
        ORDER BY u.uname";
    $result = sql_query($qry);
    if ($result) {
        while (list($uname, $uid, $level, $stat, $grp) = sql_fetch_row($result)) {
            $view = (empty($grp) || $level == 1) ? $uname : $uname . '&nbsp;&raquo;&nbsp;' . $grp;
            $useroptions[$stat][] = '<option value="' . $uid . '">' . $view . '</option>';
        }
    }

    $useroptions = (empty($useroptions)) ? '<option value="0">No Users available</option>' : $useroptions;
    return $useroptions;
}

/**
 */
function displayUsers()
{
    global $bgcolor1, $bgcolor2, $bgcolor3;
    include("header.php");
    GraphicAdmin();
    title(_USERADMIN);

    OpenTable();

    $options = getAllUsersSelectOptions1();
    echo '<fieldset><legend>' . _EDITUSER . '</legend>';
    echo '<form method="post" action="admin.php" name="edit_user_form">';
    echo '<table style="margin:auto" border="0" cellspacing="1" cellpadding="3" bgcolor="' . $bgcolor1 . '">';
    echo '<tr bgcolor="' . $bgcolor2 . '"><th>' . _YA_USERSTAT . '</th><th>' . _YA_ADM_USERENAMEGROUP . '</th><th>' . _SELECTSTAT . '</th></tr>';
    if (($GLOBALS['vkpUserregoption'] == 2) || ($GLOBALS['vkpUserregoption'] == 4)) {
        if (!empty($options[0])) {
            echo '<tr bgcolor="' . $bgcolor2 . '"><td>' . _YA_ADM_NEWUSERS . ':&nbsp;</td>';
            echo '<td bgcolor="' . $bgcolor3 . '"><select name="chng_uid_0">' . implode("", $options[0]) . '</select>&nbsp;(' . count($options[0]) . ')</td>';
            echo '<td bgcolor="' . $bgcolor3 . '" style="text-align: center;"><input type="radio" name="user_stat" value="0" /></td></tr>';
        }
    }

    if (!empty($options[1])) {
        echo '<tr bgcolor="' . $bgcolor2 . '"><td>' . _YA_ADM_ACTIVUSERS . ':&nbsp;</td>';
        echo '<td bgcolor="' . $bgcolor3 . '"><select name="chng_uid_1">' . implode("", $options[1]) . '</select>&nbsp;(' . count($options[1]) . ')</td>';
        echo '<td bgcolor="' . $bgcolor3 . '" style="text-align: center;"><input type="radio" name="user_stat" value="1" checked="checked" /></td></tr>';
    }

    if (!empty($options[2])) {
        echo '<tr bgcolor="' . $bgcolor2 . '"><td>' . _YA_ADM_DEACTIVUSERS . ':&nbsp;</td>';
        echo '<td bgcolor="' . $bgcolor3 . '"><select name="chng_uid_2">' . implode("", $options[2]) . '</select>&nbsp;(' . count($options[2]) . ')</td>';
        echo '<td bgcolor="' . $bgcolor3 . '" style="text-align: center;"><input type="radio" name="user_stat" value="2" /></td></tr>';
    }
    echo '<tr bgcolor="' . $bgcolor2 . '"><td colspan="3" style="text-align: center; vertical-align: bottom; height: 30px;"><input type="submit" value="' . _MODIFY . '" />&nbsp;&nbsp;<input type="submit" name="udelete" value="' . _DELETE . '" />';
    echo '<input type="hidden" name="op" value="modifyUser" /></td></tr>';
    echo '</table></form></fieldset>';
    CloseTable();
    echo '<br />';
    OpenTable();
    $udata['user_sexus'] = 0;
    $udata['user_stat'] = 1;
    $udata['user_ingroup'] = $GLOBALS["default_group"];
    $udata['user_bday'] = "0000-00-00";
    $newpass = makePass();
    echo '<fieldset><legend>' . _ADDUSER . '</legend>'
     . '<form action="admin.php" method="post">'
     . '<table style="margin:auto" border="0" cellspacing="1" cellpadding="3" bgcolor="' . $bgcolor1 . '">'
     . '<tr bgcolor="' . $bgcolor2 . '"><td><b>' . _NICKNAME . '</b></td>'
     . '<td bgcolor="' . $bgcolor3 . '"><input type="text" name="chng_uname" size="30" maxlength="25" /> <font class="tiny">' . _REQUIRED . '</font></td></tr>'
     . '<tr bgcolor="' . $bgcolor2 . '"><td><b>' . _PASSWORD . '</b></td>'
     . '<td bgcolor="' . $bgcolor3 . '"><input type="text" name="chng_pass" size="30" maxlength="20" value="' . $newpass . '" /> <font class="tiny">' . _REQUIRED . '</font></td></tr>'
     . adminuserform($udata)
     . '<tr bgcolor="' . $bgcolor3 . '"><td colspan="2"><input type="submit" value="' . _ADDUSERBUT . '" />'
     . '<input type="hidden" name="op" value="addUser" /></td></tr>'
     . '</table></form></fieldset>';
    CloseTable();
    include("footer.php");
}

/**
 */
function modifyUser()
{
    global $user_prefix, $prefix, $bgcolor1, $bgcolor2, $bgcolor3;

    $user_stat = (isset($_REQUEST['user_stat'])) ? $_REQUEST['user_stat'] : 1;
    $chng_uid = (isset($_REQUEST['chng_uid'])) ? $_REQUEST['chng_uid'] : 0;
    switch (intval($user_stat)) {
        case 0:
            $chng_uid = (isset($_REQUEST['chng_uid_0'])) ? (int)$_REQUEST['chng_uid_0'] : (int)$_REQUEST['chng_uid'];
            break;
        case 1:
            $chng_uid = (isset($_REQUEST['chng_uid_1'])) ? (int)$_REQUEST['chng_uid_1'] : (int)$_REQUEST['chng_uid'];
            break;
        case 2:
            $chng_uid = (isset($_REQUEST['chng_uid_2'])) ? (int)$_REQUEST['chng_uid_2'] : (int)$_REQUEST['chng_uid'];
            break;
    }

    $udata = mxGetUserDataFromUid($chng_uid, $user_stat);

    $ptitle = ($udata['user_stat'] == 1) ? _USERUPDATE : _YA_ADM_NEWUSER;
    if ($udata['user_stat'] == 0) {
        $ptitle = _YA_ADM_NEWUSER;
    } else if ($udata['user_stat'] == 1) {
        $ptitle = _USERUPDATE;
    } else if ($udata['user_stat'] == 2) {
        $ptitle = _YA_ADM_DEACTCUSER;
    }

    unset($chng_uid, $user_stat);
    include("header.php");
    GraphicAdmin();
    title(_USERADMIN);

    if (empty($udata)) {
        OpenTable();
        echo "<center><b>" . _USERNOEXIST . "</b><br /><br />" . _GOBACK . "</center>";
        CloseTable();
    } else {
        // Newsletter Modi by sidewind START
        $resultx = sql_query("SELECT status FROM ${prefix}_newsletter WHERE email='" . $udata['email'] . "'");
        list($status) = sql_fetch_row($resultx);
        $udata['newsletter'] = ($status == 2 || $udata['newsletter']) ? 1 : 0;
        // Newsletter Mod by sidewind END
        OpenTable();
        echo "<fieldset><legend>" . $ptitle . ": <em>" . $udata['uname'] . "</em></legend>"
         . "<form action=\"admin.php\" method=\"post\">"
         . "<table style=\"margin:auto\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\" bgcolor=\"$bgcolor1\">"
         . "<tr bgcolor=\"$bgcolor2\"><td>" . _USERID . "</td>"
         . "<td bgcolor=\"$bgcolor3\"><b>" . $udata['uid'] . "</b></td></tr>"
         . "<tr bgcolor=\"$bgcolor2\"><td><b>" . _NICKNAME . "</b></td>"
         . "<td bgcolor=\"$bgcolor3\"><b>" . $udata['uname'] . "</b><input type=\"hidden\" name=\"chng_uname\" value=\"" . mxEntityQuotes($udata['uname']) . "\" /></td></tr>"
         . adminuserform($udata);

        if (($GLOBALS['vkpUserregoption'] == 2) && ($udata['user_stat'] == 0)) {
            $newpass = makePass();
            echo "<tr bgcolor=\"$bgcolor2\"><td>" . _PASSWORD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"password\" name=\"chng_pass\" size=\"30\" maxlength=\"20\" value=\"" . $newpass . "\" /></td></tr>"
             . "<tr bgcolor=\"$bgcolor2\"><td>" . _RETYPEPASSWD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"password\" name=\"chng_pass2\" size=\"30\" maxlength=\"20\" value=\"" . $newpass . "\" /></td></tr>";
        } elseif (($GLOBALS['vkpUserregoption'] == 4) && ($udata['user_stat'] == 0)) {
            $querypss = "SELECT check_thepss FROM ${user_prefix}_users_temptable WHERE (uname='" . $udata['uname'] . "' AND email = '" . $udata['email'] . "')";
            $thequerypss_result = sql_query($querypss);
            if (!$thequerypss_result) {
                mxErrorScreen(_DATABASEERROR . "Get the readable password --> Activationlink mod --> users.php");
                return;
            }
            $getthedata = sql_fetch_assoc($thequerypss_result);
            $ownpass = base64_decode($getthedata['check_thepss']);
            $delqry1 = "DELETE FROM ${user_prefix}_users_temptable WHERE (uname='" . $udata['uname'] . "' AND email = '" . $udata['email'] . "')";
            $delresult1 = sql_query($delqry1);
            if (!$delresult1) {
                mxErrorScreen(_DATABASEERROR . "Delete temptable - entry --> users.php");
                return;
            }
            echo "<tr bgcolor=\"$bgcolor2\"><td>" . _PASSWORD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"password\" name=\"chng_pass\" size=\"30\" maxlength=\"20\" value=\"" . $ownpass . "\" /></td></tr>"
             . "<tr bgcolor=\"$bgcolor2\"><td>" . _RETYPEPASSWD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"password\" name=\"chng_pass2\" size=\"30\" maxlength=\"20\" value=\"" . $ownpass . "\" /></td></tr>";
        } else {
            echo "<tr bgcolor=\"$bgcolor2\"><td>" . _PASSWORD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_pass\" size=\"30\" maxlength=\"20\" /> <font class=\"tiny\">" . _FORCHANGES . "</font></td></tr>"
             . "<tr bgcolor=\"$bgcolor2\"><td>" . _RETYPEPASSWD . "</td>"
             . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_pass2\" size=\"30\" maxlength=\"20\" /> <font class=\"tiny\">" . _FORCHANGES . "</font></td></tr>";
        }
        echo "<tr bgcolor=\"$bgcolor3\"><td colspan=\"2\"><input type=\"submit\" value=\"" . _SAVECHANGES . "\" /></td></tr>"
         . "</table>"
         . "<input type=\"hidden\" name=\"chng_uid\" value=\"" . $udata['uid'] . "\" />"
         . "<input type=\"hidden\" name=\"old_user_stat\" value=\"" . $udata['user_stat'] . "\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"updateUser\" /></form></fieldset>";
        CloseTable();
    }
    include("footer.php");
}

/**
 */
function updateUser($pvs)
{
    global $user_prefix, $prefix;
    // Laengenbegrenzung, DB-Feld ist als tinytext deklariert
    $pvs['chng_bio'] = substr($pvs['chng_bio'], 0, 255);
    // Laengenbegrenzung, da im SMF nur 400 Zeichen zulaessig sind
    // ToDo: Wie sieht's damit im mxBoard aus??
    $pvs['chng_user_sig'] = substr($pvs['chng_user_sig'], 0, 400);

    $pvs = mxAddSlashesForSQL($pvs);
    extract($pvs);
    $tmp = 0;
    if (!empty($chng_pass2)) {
        if ($chng_pass != $chng_pass2) {
            include("header.php");
            GraphicAdmin();
            title(_USERADMIN);
            OpenTableAl();
            echo "<center>" . _PASSWDNOMATCH . '<br /><br />' . _GOBACK . "</center>";
            CloseTableAl();
            include("footer.php");
            exit;
        }
        $tmp = 1;
    }
    $chng_newsletter = (empty($chng_newsletter)) ? 0 : 1;
    $chng_user_ingroup = (empty($chng_user_ingroup)) ? $GLOBALS['default_group'] : $chng_user_ingroup;
    $chng_user_sexus = (empty($chng_user_sexus)) ? 0 : (int)$chng_user_sexus;
    $chng_user_stat = (empty($chng_user_stat)) ? 0 : (int)$chng_user_stat;
    $old_user_stat = (empty($old_user_stat)) ? 0 : (int)$old_user_stat;
    // / wenn user_stat auf 0 gesetzt wird aber vorher einen anderen Wert hatte, user_stat auf deaktiviert setzen (2)
    $chng_user_stat = ($chng_user_stat != $old_user_stat && $old_user_stat != 0 && $chng_user_stat == 0) ? 2 : $chng_user_stat;

    $isdate = checkdate((int)$bday_month, (int)$bday_day, (int)$bday_year);
    $bday = ($isdate) ? sprintf("%04d-%02d-%02d", $bday_year, $bday_month, $bday_day) : "";
    $setbday = (empty($bday)) ? "NULL" : "'$bday'";
    // # NEWSLETTER by sidewind START
    if ($chng_newsletter) {
        $resultx = sql_query("SELECT status from ${prefix}_newsletter WHERE email='$chng_email'");
        if (sql_num_rows($resultx) == 1) {
            sql_query("UPDATE ${prefix}_newsletter SET email = '$chng_email', status = '2', checkkey='0', html='1' WHERE email='$chng_email'");
        } else {
            $time = time();
            $userip = MX_REMOTE_ADDR;
            $userhost = gethostbyaddr(MX_REMOTE_ADDR);
            sql_query("INSERT INTO ${prefix}_newsletter SET email = '$chng_email', status = '2', checkkey='0', html='1', regdate='$time', regip='$userip', reghost='$userhost'");
        }
    } else {
        $nlquery = sql_query("SELECT id FROM ${prefix}_newsletter WHERE email='$chng_email'");
        list($nlid) = sql_fetch_row($nlquery);
        sql_query("DELETE FROM ${prefix}_newsletter WHERE email='$chng_email'");
        sql_query("DELETE FROM ${prefix}_newsletter_sendto WHERE userid='$nlid'");
    }
    // ## Newsletter by sidewind END
    if (!empty($tmp)) $cpass = md5($chng_pass);
    $newpass = (empty($tmp)) ? "" : "pass='" . $cpass . "' ";
    if ($chng_user_stat == 0 && $old_user_stat == 0 && ($GLOBALS['vkpUserregoption'] == 2 || $GLOBALS['vkpUserregoption'] == 4)) $newpass = "";

    if ($newpass) $fields[] = "$newpass";

    $fields[] = "name = '$chng_name'";
    $fields[] = "email = '$chng_email'";
    $fields[] = "femail = '$chng_femail'";
    $fields[] = "url = '$chng_url'";
    $fields[] = "user_sexus = $chng_user_sexus";
    $fields[] = "user_icq = '$chng_user_icq'";
    $fields[] = "user_aim = '$chng_user_aim'";
    $fields[] = "user_yim = '$chng_user_yim'";
    $fields[] = "user_msnm = '$chng_user_msnm'";
    $fields[] = "user_from = '$chng_user_from'";
    $fields[] = "user_occ = '$chng_user_occ'";
    $fields[] = "user_intrest = '$chng_user_intrest'";
    // $fields[] = "user_viewemail= '$chng_user_viewemail'";
    // $fields[] = "user_avatar = '$chng_user_avatar'";
    $fields[] = "bio = '$chng_bio'";
    $fields[] = "user_sig = '$chng_user_sig'";
    $fields[] = "newsletter = '$chng_newsletter'";
    $fields[] = "user_ingroup = $chng_user_ingroup";
    $fields[] = "user_stat = $chng_user_stat";
    $fields[] = "user_bday = $setbday"; // ohne anfhrz.
    $qry = "UPDATE ${user_prefix}_users SET " . implode(', ', $fields) . " where uid = " . $chng_uid;
    $result = sql_query($qry);

    if ($result) {
        if ($chng_user_stat == 1 && $old_user_stat == 0 && ($GLOBALS['vkpUserregoption'] == 2 || $GLOBALS['vkpUserregoption'] == 4)) {
            $subject = _YA_REG_MAILMSG4 . " " . $chng_uname;
            $message = _HELLO . " " . $chng_uname . "\n\n";
            $message .= _YA_REG_MAILMSG3 . "\n\n";
            $message .= "  -" . _NICKNAME . ":\t " . $chng_uname . "\n";
            $message .= "  -" . _PASSWORD . ":\t " . $chng_pass . "\n";
            $message .= "\n\n" . $GLOBALS['slogan'] . "\n-----------------------------------------------------------\n\n";
            $message .= PMX_HOME_URL . "/modules.php?name=Your_Account\n\n\n\n\n\n\n\n\npowered by: " . MX_VERSION . " (http://www.pragmaMx.org/)";
            mxMail($chng_email, mxHtmlEntityDecode($subject), mxHtmlEntityDecode($message), $GLOBALS['adminmail'], "text");
        }
    } else {
        mxErrorScreen(_DATABASEERROR . '<br /><br />' . $qry);
        return;
    }
    if ($chng_user_stat != $old_user_stat) {
        $location = "admin.php?op=mod_users";
    } else {
        $location = "admin.php?op=modifyUser&amp;chng_uid=" . $chng_uid . "&amp;user_stat=" . $chng_user_stat;
    }
    mxRedirect($location, _CHANGESAREOK);
}

/**
 */
function addUser($pvs)
{
    global $user_prefix, $prefix;
    // Laengenbegrenzung, DB-Feld ist als tinytext deklariert
    $pvs['chng_bio'] = substr($pvs['chng_bio'], 0, 255);
    // Laengenbegrenzung, da im SMF nur 400 Zeichen zulaessig sind
    // ToDo: Wie sieht's damit im mxBoard aus??
    $pvs['chng_user_sig'] = substr($pvs['chng_user_sig'], 0, 400);

    $pvs = mxAddSlashesForSQL($pvs);
    extract($pvs);
    $chng_uname = trim($chng_uname);
    if (!($chng_uname && $chng_email && $chng_pass && !ereg("[^ a-zA-Z0-9_-]", $chng_uname))) {
        include("header.php");
        GraphicAdmin();
        title(_USERADMIN);
        OpenTableAl();
        echo "<center><b>" . _NEEDTOCOMPLETE . "</b><br /><br />" . _GOBACK . "</center>";
        CloseTableAl();
        include("footer.php");
        die();
    }
    $result = sql_query("select uid from ${user_prefix}_users where uname='" . mxAddSlashesForSQL($chng_uname) . "'");
    list($new_uid) = sql_fetch_row($result);
    if (!empty($new_uid)) {
        include("header.php");
        GraphicAdmin();
        title(_USERADMIN);
        OpenTableAl();
        echo "<center><b>" . _USERYESEXIST . "</b><br /><br />" . _GOBACK . "</center>";
        CloseTableAl();
        include("footer.php");
        die();
    }

    $chng_pass = md5($chng_pass);
    // $chng_user_viewemail = (empty($chng_user_viewemail)) ? 0 : 1;
    $chng_newsletter = (empty($chng_newsletter)) ? 0 : 1;

    $chng_user_ingroup = (empty($chng_user_ingroup)) ? $GLOBALS['default_group'] : $chng_user_ingroup;
    $chng_user_sexus = (empty($chng_user_sexus)) ? 0 : (int)$chng_user_sexus;
    $chng_user_stat = (empty($chng_user_stat)) ? 0 : (int)$chng_user_stat;

    $isdate = checkdate((int)$bday_month, (int)$bday_day, (int)$bday_year);
    $bday = ($isdate) ? sprintf("%04d-%02d-%02d", $bday_year, $bday_month, $bday_day) : "";
    $setbday = (empty($bday)) ? "NULL" : "'$bday'";

    $user_regdate = mxGetNukeUserregdate();
    $user_regtime = time();

    $fields[] = "name = '$chng_name'";
    $fields[] = "uname = '$chng_uname'";
    $fields[] = "email = '$chng_email'";
    $fields[] = "femail = '$chng_femail'";
    $fields[] = "url = '$chng_url'";
    $fields[] = "user_regdate = '$user_regdate'";
    $fields[] = "user_icq = '$chng_user_icq'";
    $fields[] = "user_aim = '$chng_user_aim'";
    $fields[] = "user_yim = '$chng_user_yim'";
    $fields[] = "user_msnm = '$chng_user_msnm'";
    $fields[] = "user_from = '$chng_user_from'";
    $fields[] = "user_occ = '$chng_user_occ'";
    $fields[] = "user_intrest = '$chng_user_intrest'";
    // $fields[] = "user_viewemail = '$chng_user_viewemail'";
    // $fields[] = "user_avatar = '$chng_user_avatar'";
    $fields[] = "bio = '$chng_bio'";
    $fields[] = "user_sig = '$chng_user_sig'";
    $fields[] = "pass = '$chng_pass'";
    $fields[] = "newsletter = $chng_newsletter";
    $fields[] = "user_ingroup = $chng_user_ingroup";
    $fields[] = "user_regtime = $user_regtime";
    $fields[] = "user_sexus = $chng_user_sexus";
    $fields[] = "user_bday = $setbday";
    $fields[] = "user_stat = $chng_user_stat";

    $qry = "INSERT INTO ${user_prefix}_users SET " . implode(', ', $fields);
    $result = sql_query($qry);
    // print $qry; exit;
    if (!$result) {
        mxErrorScreen('Database error, cannot add to users-table <br />(' . mysql_error() . ')', "Error");
        die();
    }
    $uid = sql_insert_id();
    if (!empty($chng_newsletter) && $result) {
        // # NEWSLETTER by sidewind START
        if ($chng_newsletter) {
            $resultx = sql_query("SELECT status from ${prefix}_newsletter WHERE email='$chng_email'");
            if (sql_num_rows($resultx) == 1) {
                sql_query("UPDATE ${prefix}_newsletter SET email = '$chng_email', status = '2', checkkey='0', html='1' WHERE email='$chng_email'");
            } else {
                $time = time();
                $userip = MX_REMOTE_ADDR;
                $userhost = gethostbyaddr(MX_REMOTE_ADDR);
                sql_query("INSERT INTO ${prefix}_newsletter SET email = '$chng_email', status = '2', checkkey='0', html='1', regdate='$time', regip='$userip', reghost='$userhost'");
            }
        }
        // ## Newsletter by sidewind END
    }
    mxRedirect("admin.php?op=modifyUser&chng_uid=" . $uid . "&user_stat=" . $chng_user_stat, _CHANGESAREOK);
}

/**
 */
function delUser()
{
    global $user_prefix, $prefix;

    if (isset($_POST['udelete']) && isset($_POST['user_stat'])) {
        /* Loeschen ueber Adminmenue */
        $user_stat = (empty($_POST['user_stat'])) ? 0 : intval($_POST['user_stat']);
        switch ($user_stat) {
            case 0:
                $chng_uid = $_POST['chng_uid_0'];
                break;
            case 1:
                $chng_uid = $_POST['chng_uid_1'];
                break;
            case 2:
                $chng_uid = $_POST['chng_uid_2'];
                break;
        }
    } else {
        /* Loeschen ueber Mitgliederliste etc. */
        $chng_uid = (empty($_REQUEST['chng_uid'])) ? 0 : intval($_REQUEST['chng_uid']);
    }

    $result = sql_query("SELECT uid, uname, user_stat FROM ${user_prefix}_users WHERE uid=" . intval($chng_uid));
    list($del_uid, $del_uname, $del_stat) = sql_fetch_row($result);
    if (empty($del_uid) || $del_stat == -1 || $del_uid === 1) {
        $msg = '<div class="option"><b>' . _USERNOEXIST . '</b></div><br />' . _GOBACK;
    } else {
        $msg = '<div class="option"><b>' . _DELETEUSER . '</b></div>
         ' . _SURE2DELETE . '&nbsp;<b>' . htmlspecialchars($del_uname) . '</b>?<br /><br />
         <form action="admin.php?op=delUserConf" method="post">
            <input type="hidden" name="op" value="delUserConf" />
            <input type="hidden" name="del_uid" value="' . $del_uid . '" />
            <input type="submit" name="action" value="' . _YES . '" /> &nbsp;
            <input type="submit" value="' . _NO . '" />
         </form>';
    }
    include("header.php");
    GraphicAdmin();
    title(_USERADMIN);
    OpenTableAl();
    echo "<center>$msg</center>";
    CloseTableAl();
    include("footer.php");
}

/**
 */
function delUserConf($pvs)
{
    global $user_prefix, $prefix;

    extract($pvs);
    if (!isset($pvs['action']) || $pvs['action'] != _YES) {
        displayUsers();
        return;
    }

    $del_uid = (empty($del_uid)) ? 0 : intval($del_uid);
    if (!$del_uid || $del_uid === 1) {
        include("header.php");
        GraphicAdmin();
        OpenTableAl();
        echo "<center><div class=\"option\"><b>" . _USERNOEXIST . "</b></div><a href=\"admin.php?op=mod_users\">" . _USERADMIN . "</a></center>";
        CloseTableAl();
        include("footer.php");
    } else {
        $result = sql_query("SELECT uname, email, femail, user_stat FROM ${user_prefix}_users WHERE uid=$del_uid");
        list($uname, $email, $femail, $user_stat) = sql_fetch_row($result);
        // Sollte ein Avatar hochgeladen sein, diesen lschen!
        if (mxIsAvatarUploaded($uname)) {
            mxDeleteAvatar($uname);
        }
        if (empty($user_stat)) { // wenn noch nicht aktiviert, komplett lschen
            sql_query("DELETE FROM ${user_prefix}_users WHERE uid='$del_uid'");
            sql_query("DELETE FROM ${user_prefix}_users_temptable WHERE (uname='" . $uname . "' AND email = '" . $email . "')");
        } else {
            mt_srand((double)microtime() * 1000000);
            $fields[] = "user_stat = -1";
            $fields[] = "uid = $del_uid";
            $fields[] = "uname = '$uname'";
            $fields[] = "name = 'deleted (admin)'";
            $fields[] = "pass = '" . md5(mt_rand()) . "'";
            $qry = "REPLACE INTO ${user_prefix}_users SET " . implode(', ', $fields);
            sql_query($qry);
        }
        sql_query("UPDATE ${prefix}_authors SET user_uid=NULL WHERE user_uid=$del_uid");
        sql_query("DELETE FROM ${prefix}_userpoints WHERE uid='$del_uid'");
        sql_query("DELETE FROM ${prefix}_userguest WHERE touser='$uname'");
        sql_query("DELETE FROM ${prefix}_priv_msgs WHERE to_userid='$del_uid'");
        sql_query("DELETE FROM ${prefix}_visitors WHERE uid='$del_uid'");
        $nlquery = sql_query("SELECT id FROM ${prefix}_newsletter WHERE email='$email' OR email='$femail'");
        list($nlid) = sql_fetch_row($nlquery);
        if ($nlid) {
            sql_query("DELETE FROM ${prefix}_newsletter WHERE email='$email' OR email='$femail'");
            sql_query("DELETE FROM ${prefix}_newsletter_sendto WHERE userid='$nlid'");
        }
        if (@file_exists(PMX_MODULES_DIR . DS . "eBoard/settings.php")) {
            include(PMX_MODULES_DIR . DS . "eBoard/settings.php");
            $qry = "UPDATE " . $table_members . " SET
                password = '" . md5(mt_rand()) . "',
                email = Null,
                site = Null,
                status = 'Member',
                sig = Null,
                avatar = 'blank.gif',
                customstatus = 'deleted',
                newsletter = 'no',
                notifyme = 'no',
                notifyemail = 'no',
                pmuserid = '0'
                WHERE (username='" . $uname . "')";
            sql_query($qry);
        }
        mxRedirect("admin.php?op=mod_users", _DELETEAREOK);
    }
}

/**
 */
function adminuserform($udata = array())
{
    global $user_prefix, $prefix, $bgcolor1, $bgcolor2, $bgcolor3;
    $udata['user_age'] = (empty($udata['user_age'])) ? "?" : $udata['user_age'];
    $selNewsletter = (empty($udata['newsletter'])) ? '' : ' checked="checked"';
    $out = ""
     . "<tr bgcolor=\"$bgcolor2\"><td><b>" . _EMAIL . "</b></td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_email\" value=\"" . ((empty($udata['email'])) ? "" : htmlspecialchars($udata['email'])) . "\" size=\"60\" maxlength=\"100\" /> <font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td><b>" . _YA_USERSTAT . "</b></td>"
     . "<td bgcolor=\"$bgcolor3\"><select name=\"chng_user_stat\">" . getUserStatOptions($udata['user_stat']) . "</select><font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td><b>" . _YA_INGROUP . "</b></td>"
     . "<td bgcolor=\"$bgcolor3\"><select name=\"chng_user_ingroup\">" . getAllAccessLevelSelectOptions($udata['user_ingroup']) . "</select><font class=\"tiny\">" . _REQUIRED . "</font></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _NAME . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_name\" value=\"" . ((empty($udata['name'])) ? "" : htmlspecialchars($udata['name'])) . "\" size=\"60\" maxlength=\"60\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _YA_USEXUS . "</td>"
     . "<td bgcolor=\"$bgcolor3\">" . vkpSexusSelect('chng_user_sexus', $udata['user_sexus']) . "</td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _YA_UBDAY . "</td>"
     . "<td bgcolor=\"$bgcolor3\">" . vkpBdaySelect($udata['user_bday']) . " (" . $udata['user_age'] . ")</td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _FAKEEMAIL . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_femail\" value=\"" . ((empty($udata['femail'])) ? "" : htmlspecialchars($udata['femail'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _URL . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_url\" value=\"" . ((empty($udata['url'])) ? "" : htmlspecialchars($udata['url'])) . "\" size=\"60\" maxlength=\"255\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _ICQ . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_icq\" value=\"" . ((empty($udata['user_icq'])) ? "" : htmlspecialchars($udata['user_icq'])) . "\" size=\"60\" maxlength=\"50\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _AIM . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_aim\" value=\"" . ((empty($udata['user_aim'])) ? "" : htmlspecialchars($udata['user_aim'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _YIM . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_yim\" value=\"" . ((empty($udata['user_yim'])) ? "" : htmlspecialchars($udata['user_yim'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _MSNM . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_msnm\" value=\"" . ((empty($udata['user_msnm'])) ? "" : htmlspecialchars($udata['user_msnm'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _LOCATION . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_from\" value=\"" . ((empty($udata['user_from'])) ? "" : htmlspecialchars($udata['user_from'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _OCCUPATION . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_occ\" value=\"" . ((empty($udata['user_occ'])) ? "" : htmlspecialchars($udata['user_occ'])) . "\" size=\"60\" maxlength=\"100\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _INTERESTS . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"text\" name=\"chng_user_intrest\" value=\"" . ((empty($udata['user_intrest'])) ? "" : htmlspecialchars($udata['user_intrest'])) . "\" size=\"60\" maxlength=\"150\" /></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _EXTRAINFO . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><textarea name=\"chng_bio\" rows=\"6\" cols=\"60\">" . ((empty($udata['bio'])) ? "" : htmlspecialchars($udata['bio'])) . "</textarea></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _SIGNATURE . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><textarea name=\"chng_user_sig\" rows=\"6\" cols=\"60\">" . ((empty($udata['user_sig'])) ? "" : htmlspecialchars($udata['user_sig'])) . "</textarea></td></tr>"
     . "<tr bgcolor=\"$bgcolor2\"><td>" . _NEWSLETTER . "</td>"
     . "<td bgcolor=\"$bgcolor3\"><input type=\"checkbox\" name=\"chng_newsletter\" value=\"1\"" . $selNewsletter . " />" . _YES . "</td></tr>";
    // ."<tr bgcolor=\"$bgcolor2\"><td>"._OPTION."</td>"
    // ."<td bgcolor=\"$bgcolor3\"><input type=\"checkbox\" name=\"chng_user_viewemail\" value=\"1\" /> "._ALLOWUSERS."</td></tr>";
    return $out;
    // ToDo: Die Textareas sollten mittels JavaScript eine (angezeigte = Restzeichen) Laengenbegrenzung haben (wie im SMF-Profil).
}

switch ($_REQUEST['op']) {
    case "mod_users":
        displayUsers();
        break;

    case "modifyUser":
        if (isset($_POST['udelete'])) {
            delUser();
        } else {
            modifyUser();
        }
        break;

    case "updateUser":
        updateUser($_POST);
        break;

    case "delUser":
        delUser();
        break;

    case "delUserConf":
        delUserConf($_POST);
        break;

    case "addUser":
        addUser($_POST);
        break;
}

?>